/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.expression;

import engcalculator.data.IntervalList;
import engcalculator.function.prefix.PrefixFunction;
import java.util.HashMap;
import java.util.LinkedList;

public class Expression {
    private final static boolean DEBUG = false;
    private final static boolean COMPILE = false; //compiler does not understand []; and loops
    private String expression;
    private Interpeter interpeter;
    private Tokenizer tokenizer;

    public Expression (String expression, LinkedList<String> varfunc) throws Exception {
        this.expression = expression;
        tokenizer = new Tokenizer();       
        if (COMPILE) {
            interpeter = new Compiler (tokenizer.tokenize(varfunc, expression));
            ((Compiler) interpeter).compile();
        }
        else interpeter = new Interpeter (tokenizer.tokenize(varfunc, expression));
        
    }

    public IntervalList evaluate(HashMap<String, PrefixFunction> parameters ) throws Exception {
        if (DEBUG) System.out.println("Evaluating expression: "+expression+" with parameters: "+parameters);
        tokenizer.setParameters(parameters);
        if (COMPILE) return ((Compiler) interpeter).execute();
        else return interpeter.parse();
    }

    public LinkedList<String> listOfDuplicatedIntervals () {
        return interpeter.listOfDuplicatedIntervals ();
    }

    @Override
    public String toString(){
        return expression;
    }

    public void stopCalculus() {
        if (interpeter != null) interpeter.stopCalculus();
    }

}
