/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.arithmetic;

import engcalculator.function.infix.*;
import engcalculator.data.Interval;

/**
 *
 * @author simone
 */
public class Mul extends DualInputSingleOutputInfixFunction {
    private final static String[] EXAMPLE_LEFT = {"6_9"};
    private final static String[] EXAMPLE_RIGHT = {"1_3"};
    private final static String[] RESULT = {"6_27"};

    public Mul() {
        super ("*", true, true, "a * b multiply the interval a for b as per Kaucher arithmetic. ", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public Interval _computeIntervals (Interval x, Interval y) throws Exception {
        double x1 = x.getLeft(), x2 = x.getRight(), y1 = y.getLeft(), y2 = y.getRight();

        if (x.isPositive()) {
            if (y.isPositive()) return new Interval (x1*y1, x2*y2).setOuter();
            if (y.isNegative()) return new Interval (x2*y1, x1*y2).setOuter();
            if (y.isProper())   return new Interval (x2*y1, x2*y2).setOuter();
            return new Interval (x1*y1, x1*y2).setOuter();
        } else if (x.isNegative()) {
            if (y.isPositive()) return new Interval (x1*y2, x2*y1).setOuter();
            if (y.isNegative()) return new Interval (x2*y2, x1*y1).setOuter();
            if (y.isProper())   return new Interval (x1*y2, x1*y1).setOuter();
            return new Interval (x2*y2, x2*y1).setOuter();
        } else if (x.isProper()) {
            if (y.isPositive()) return new Interval (x1*y2, x2*y2).setOuter();
            if (y.isNegative()) return new Interval (x2*y1, x1*y1).setOuter();
            if (y.isProper())   return  new Interval (Math.min(x1*y2, x2*y1), Math.max(x1*y1, x2*y2)).setOuter();
            return new Interval (0);
        } else {
            if (y.isPositive()) return new Interval (x1*y1, x2*y1).setOuter();
            if (y.isNegative()) return new Interval (x2*y2, x1*y2).setOuter();
            if (y.isProper())   return new Interval (0);
            return new Interval (Math.max(x1*y1, x2*y2), Math.min(x1*y2, x2*y1)).setOuter();

        }

    }
}
