/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.interval;

import engcalculator.data.Interval;
import engcalculator.function.infix.DualInputSingleOutputInfixFunction;

/**
 *
 * @author simone
 */
public class IntervalByToleranceBuilder extends DualInputSingleOutputInfixFunction {
    private final static String[] EXAMPLE_LEFT = {"2", "3,4,5"};
    private final static String[] EXAMPLE_RIGHT = {"4","5"};
    private final static String[] RESULT = {"2%4", "3%5,4%5,5%5"};

    public IntervalByToleranceBuilder() {
        super("%", true, true, "a%b generates an interval with the value of a as value and the value of b as tolerance. Can be used to add a tolerance to a list of intervals.", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }


    @Override
    public Interval _computeIntervals (Interval leftSide, Interval rightSide) throws Exception {
        double first = leftSide.getLeft();
        double second = leftSide.getRight();
        double val = leftSide.getVal();
        double tol = rightSide.getVal()*val/100;

        if (val >= 0) {
            first -= tol;
            second += tol;
        } else {
            first += tol;
            second -= tol;
        }
        return  new Interval(first, second);
    }

}
