/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.list;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.infix.InfixFunction;

/**
 *
 * @author simone
 */
public class Get extends InfixFunction {
    private final static String[] EXAMPLE_LEFT = {"1,2,3", "1,2,3,4","1,2,3,4","(1,2,3,4)#2"};
    private final static String[] EXAMPLE_RIGHT = {"1","1,3","0,0,1","1_1"};
    private final static String[] RESULT = {"2", "2,4", "1,1,2","4"};

    public Get() {
        super (":", (byte) -1, (byte) -1, false, true, "Given a list the ':' is able to get elements at the required positions (0 is the first element). For list or row vector only the left part of the interval is read while for matrix the left part represent the columns while the right represents the row, both begins from 0.", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList leftSide, IntervalList rightSide) throws Exception {
        IntervalList result = new IntervalList ();
        int column, row;
        final int rightSize = rightSide.size();
        Interval i;
        for (int index=0; index<rightSize; ++index) {
            i = rightSide.get(index);

            column = (int) i.getLeft();
            if (column >= leftSide.getColumns()) throw new CalculusException ("Column out of range");

            if (leftSide.getRows() > 1) {
                row = (int) i.getRight();
                if (row >= leftSide.getRows()) throw new CalculusException ("Row out of range");


                result.add(leftSide.get(row, column));
            } else result.add(leftSide.get(column));

        }
        return result;
    }

}
