/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix;


import engcalculator.expression.Expression;
import engcalculator.data.IntervalList;
import engcalculator.function.CalculusException;
import engcalculator.variable.Variable;
import java.util.HashMap;
import java.util.List;

/**
 *
 * @author simone
 */
public class UserFunction extends PrefixFunction {
    private final Expression expression;
    private final List<String> varnames;

    public UserFunction(String name, byte numbArgs, boolean acceptLists, String help, Expression expression, List<String> varnames) {
        super (name, numbArgs, acceptLists, false, help, null, null);
        this.expression = expression;
        this.varnames = varnames;
    }


    @Override
    public final IntervalList _compute(IntervalList input) throws Exception {
        HashMap<String, PrefixFunction> temporaryVars = new HashMap<String, PrefixFunction> ();
        PrefixFunction f;
        for (int i=0;i<varnames.size();++i) {
            String fname = input.get(i).getName();
            if (fname != null) {
                f = PrefixFunction.getFunction(fname);
                if (f == null) throw new CalculusException("It was not possible to find a function called "+fname);
                temporaryVars.put(varnames.get(i), f);
            }
            else temporaryVars.put(varnames.get(i), new Variable (varnames.get(i), input.get(i), false, "Temporary variable"));
        }
        return expression.evaluate(temporaryVars);
    }

    @Override
    public String getHelp() {
        return "\nUser defined function"+super.getHelp();
    }

}
