/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.matrix;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.data.MatrixIntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class MatrixIdentity extends PrefixFunction {
    private final static String[] EXAMPLE = {"2"};
    private final static String[] RESULT = {"(1,0,0,1)#2"};

    public MatrixIdentity() {
        super("identity", (byte) 1, false, true, "Build an identity matrix of required size", EXAMPLE, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        if (! input.getFirst().isInteger()) throw new CalculusException ("It is required an integer input as dimension");
        final int cs = (int) input.getFirst().getLeft();
        MatrixIntervalList result = new MatrixIntervalList (cs);
        for (int c=0; c<cs; ++c)
            for (int r=0; r<cs; ++r)
                if (r == c) result.add(new Interval(1));
                else result.add(new Interval(0));
        return result;

    }

}
