/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.system;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class TimeMs extends PrefixFunction {
    private final static long START_TIME = System.currentTimeMillis();
    private final static String[] EXAMPLE = {"t=timems();t - timems()"};
    private final static String[] RESULT = {"0"};
    
    public TimeMs() {
        super("timems", (byte) 0, true, true, "Returns the current time in milliseconds. Note that while the unit of time of the return value is a millisecond, the granularity of the value depends on the underlying operating system and may be larger. For example, many operating systems measure time in units of tens of milliseconds.", EXAMPLE, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        return new IntervalList ( new Interval (System.currentTimeMillis()-START_TIME));
    }
}
